﻿(function () {
    angular
		.module('parkIt.directives')
		.directive('deleteConfirmer', deleteConfirmer);

    function deleteConfirmer() {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                deletingId: '=',
                confirmHandler: '=',
                side: '@',
                showHeader: '=',
                confirmButtonText: '=',
                resources: '='
            },
            link: function ($scope, $element) {
                var $parent = $element.parent();

                $scope.side = $scope.side ? $scope.side : 'right';

                $element.on('click', function (e) {
                    e.stopPropagation();
                });

                $parent.on('click', function (e) {
                    setPosition();
                    $element.show();
                    e.stopPropagation();
                });

                $(document).on('click', function () {
                    $element.hide();
                });

                $scope.confirm = function () {
                    if ($scope.confirmHandler) {
                        $scope.confirmHandler($scope.deletingId);
                    }

                    $element.hide();
                };

                $scope.hide = function () {
                    $element.hide();
                };

                function getCenterPos(l1, l2) {
                    return l1 > l2 ? l1 / 2 - l2 / 2 : -(l1 / 2);
                };

                function setPosition() {
                    var left = parseInt($parent.offset().left),
                        top = parseInt($parent.offset().top);

                    if ($scope.side === 'bottom') {
                        left += getCenterPos($parent.outerWidth(), $element.outerWidth());
                        top += $parent.outerHeight() + 5;
                    }
                    else if ($scope.side === 'right') {
                        left += $parent.outerWidth() + 5;
                        top += getCenterPos($parent.outerHeight(), $element.outerHeight());
                    }

                    $element.css({
                        'left': left,
                        'top': top
                    });
                };
            },
            templateUrl: 'Components/DeleteConfirmer/deleteConfirmer.html'
        };
    };
})();