﻿(function () {
    angular
		.module('parkIt.directives')
		.directive('dropdown', dropdown);

    function dropdown() {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                options: '=',
                selectedValue: '=',
                placeholder: '=',
                disabled: '='
            },
            link: function ($scope, $element) {
                $element.on('click', function (e) {
                    e.stopPropagation();
                });

                $(document).on('click', function () {
                    $scope.$apply(function () {
                        $scope.isShowList = false;
                    });
                });

                $scope.selectedTitle = undefined;

                $scope.isShowList = false;

                $scope.toggleList = function () {
                    $scope.isShowList = !$scope.isShowList;
                }

                $scope.setValue = function (value) {
                    $scope.selectedValue = value;
                    $scope.isShowList = false;
                }

                $scope.$watch('selectedValue', function (value) {
                    if (!value) {
                        $scope.selectedTitle = undefined;
                    }
                    else {
                        $scope.selectedTitle = $scope.options.filter(function (option) {
                            return option.value === value;
                        })[0].title;
                    }
                });
            },

            templateUrl: 'Components/Dropdown/dropdown.html'
        };
    };
})();