﻿(function () {
	angular
		.module('parkIt.directives')
		.directive('globalPopup', ['$timeout', 'globalPopup', globalPopup]);

	function globalPopup($timeout, globalPopup) {
		return {
			restrict: 'E',
			replace: true,
			link: function ($scope, $element) {
			    var $popup = $element.find('.js-popup'),
			        $shadow = $element.find('.js-popup-shadow');

				$scope.service = globalPopup;
				$scope.options = globalPopup.options;

				$scope.$watch('service.options', function (options) {
					$scope.options = options;
				});

				$scope.onload = function (e) {
				    $popup.show();

				    $timeout(function () {
				        setPosition();
				    });
				};

				$scope.hidePopup = function () {
				    $scope.service.close();
				};

				$scope.$watch('service.isOpen', function (isOpen) {
				    if (isOpen) {
				        $shadow.fadeIn();
				        $popup.fadeIn();
				    }
				    else {
				        $popup.fadeOut();
				        $shadow.fadeOut();
				    }
				});

				$(window).on('resize', function () {
					if ($popup.is(':visible')) {
						$popup.css("top", $popup.attr('data-default-top'));
						$popup.css({ 'top': getTopPos() + 'px' });
					}
				});

				function getTopPos() {
					return Math.max(10, window.innerHeight / 2 - $popup.height() / 2 - 50);
				}

				function setPosition() {
					$popup
						.attr('data-default-top', $popup.css('top'))
						.css({ 'margin-left': -$popup.width() / 2 + 'px', 'top': getTopPos() + 'px' });
				}
			},

			templateUrl: 'Components/GlobalPopup/globalPopup.html'
		};
	};
})();