﻿(function () {
    angular
		.module('parkIt.directives')
		.directive('leftMenu', ['localization', 'leftMenu', leftMenu]);

    function leftMenu(resources, leftMenuService) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                showLegendHandler: '=?',
                showTermsHandler: '=?',
                openMapHandler: '=?',
                openAdditionalHandler: '=?',
                openAboutHandler: '=?'
            },
            link: function ($scope, $element) {
                var $sticker = $element.find('.js-sticker'),
                    $menu = $element.find('.js-menu'),
                    startX = undefined,
                    endX = undefined;

                $scope.resources = resources;

                $scope.leftMenuService = leftMenuService;

                $sticker
                    .on('touchstart', function (e) {
                        var touch = e.originalEvent.touches[0];

                        startX = touch.clientX;
                    })
                    .on('touchmove', function (e) {
                        var touch = e.originalEvent.touches[0];

                        endX = touch.clientX;

                        e.preventDefault();

                        return false;
                    })
                    .on('touchend', function (e) {
                        if (endX - startX > 0) {
                            showMenu();
                        }
                    });

                $menu
                    .on('touchstart', function (e) {
                        var touch = e.originalEvent.touches[0];

                        startX = touch.clientX;
                    })
                    .on('touchmove', function (e) {
                        var touch = e.originalEvent.touches[0];

                        endX = touch.clientX;

                        e.preventDefault();

                        return false;
                    })
                    .on('touchend', function (e) {
                        if (startX - endX > 0) {
                            hideMenu();
                        }
                    })
                    .on('click', function () {
                        hideMenu();
                    });

                $scope.$watch('leftMenuService.openRequestFlag', function (openRequestFlag) {
                    if(openRequestFlag)
                    {
                        showMenu();
                    }
                });

                function showMenu() {
                    $menu.addClass('show');
                    $menu.addClass('inited');
                }

                function hideMenu(dom) {
                    $menu.removeClass('show');

                    $scope.$apply(function () {
                        $scope.leftMenuService.menuClosedHandler();
                    });
                }
            },

            templateUrl: 'Components/LeftMenu/leftMenu.html'
        };
    };
})();