﻿(function () {
    angular
		.module('parkIt.services')
		.service('geolocation', ['$q', '$timeout', geolocation]);

    function geolocation($q, $timeout) {

        var self = this;
       
        self.getPosition = function () {
            var deferred = $q.defer();

            if (!navigator || !navigator.geolocation) {
                deferred.reject();
            }

            navigator.geolocation.getCurrentPosition(function (position) {
                deferred.resolve({
                    position: new GeoPoint(position.coords.latitude, position.coords.longitude),
                    heading: position.coords.heading,
                    speed: position.coords.speed,
                    accuracy: position.coords.accuracy
                });
            }, function () {
                deferred.reject();
            },
            {
                timeout: 5000
            });

            return deferred.promise;
        };
    }
})();