﻿(function () {
    angular
		.module('parkIt.services')
		.service('localization', ['$rootScope', '$http', '$timeout', localization]);

    function localization($rootScope, $http, $timeout) {
        var self = this;

        self.currentLanguage = null;

        self.availableLanguages = null;

        self.get = function (section, name) {
            var args = Array.prototype.slice.call(arguments, 2);

            if (!Resources ||
				!Resources[section] ||
				!Resources[section][self.currentLanguage] ||
				!Resources[section][self.currentLanguage][name])
            	return null;

            return String.prototype.format.apply(Resources[section][self.currentLanguage][name], args);
        };

        self.setLanguage = function (lang) {
            $timeout(function () {
                self.currentLanguage = lang;
            }, 0);
        };

        self.init = function (availableLanguages) {
        	self.availableLanguages = availableLanguages;
	        self.currentLanguage = availableLanguages[0];
        };
    };
})();