﻿(function () {
    angular
		.module('parkIt.services')
		.service('purchases', ['$rootScope', '$q', 'localization', purchases]);

    function purchases($rootScope, $q, resources) {
        var self = this,
            store = null,

            ownedPurchases = [],

            purchasesLocalInfo = [
                new Purchase({
                    id: 'su.parkit.mobile.carlocation',
                    
                    pictures: [
                        {
                            thumb: 'Images/Purchases/CarLocation/1.png',
                            img: 'Images/Purchases/CarLocation/1.png',
                            description: 'Screenshot'
                        },
                        {
                            thumb: 'Images/Purchases/CarLocation/2.png',
                            img: 'Images/Purchases/CarLocation/2.png',
                            description: 'Screenshot'
                        },
                        {
                            thumb: 'Images/Purchases/CarLocation/3.png',
                            img: 'Images/Purchases/CarLocation/3.png',
                            description: 'Screenshot'
                        }
                    ]
                })
            ];

        self.init = function (s) {
            var deferred = $q.defer();

            store = s;

            store.register({
                id: "su.parkit.mobile.carlocation",
                alias: "carlocation",
                type: store.NON_CONSUMABLE
            });

            store.ready(function () {
                $rootScope.$apply(function () {
                    deferred.resolve();
                });
            });

            store.when('product').approved(function (p) {
                p.finish();
            });

            store.when("product").owned(function (p) {
                
                $rootScope.$apply(function () {
                    if (ownedPurchases.indexOf(p.id) == -1) {
                        ownedPurchases.push(p.id);
                    }
                });
            });

            store.refresh();

            return deferred.promise;
        };

        self.getAvailablePurchases = function () {
            if (!store)
                return purchasesLocalInfo; //TODO только для дебага

            return purchasesLocalInfo
                        .map(function (p) {
                            p.product = store.get(p.id);

                            return p;
                        })
                        .filter(function (p) {
                            return p.product.state != store.INVALID;
                        });
        };

        self.order = function (purchaseId) {
            store.order(purchaseId);
        };

        self.getOwnedPurchases = function () {
            return ownedPurchases;
        };

        self.isOwned = function (itemId) {
            return ownedPurchases.indexOf(itemId) >= 0;
        };

        self.restore = function () {
        	store.refresh();
        };
    }
})();