﻿(function () {
    angular
		.module('parkIt.controllers')
		.controller('GlobalController', [
            '$scope',
            '$location',
            'globalPopup',
            'browserDetection',
            GlobalController]);

    function GlobalController(
        $scope,
        $location,
        globalPopup,
        browserDetection)
    {

        $scope.Environment = Environment;

        $scope.isMobile = browserDetection.isMobile;

        $scope.showManageButton = false;

        $scope.showRatingButton = false;

        $scope.showLegend = localStorage.getItem('showLegend') == undefined;

        $scope.openMainPage = function () {
            $location.search({});
            $location.path('/');
        };

        $scope.openTermsOfUsePage = function () {
            $location.path('termsOfUse');
        };

        $scope.openPurchasesPage = function () {
            $location.path('purchases');
        };

        $scope.openAboutPage = function () {
        	$location.path('about');
        };

        $scope.showLegendHandler = function () {
            $scope.showLegend = true;
        };

        $scope.hideLegend = function () {
            localStorage.setItem('showLegend', false);
            $scope.showLegend = false;
        };

        $scope.isMainPage = function () {
            return $location.path() === '/';
        };
    };
})();