﻿angular.module('parkIt.services', []);
angular.module('parkIt.controllers', []);
angular.module('parkIt.directives', []);

angular.module('parkItApp',
    [
        'ngRoute',
        'parkIt.services',
        'parkIt.controllers',
        'parkIt.directives'
    ])

	.config(['$routeProvider',
        function ($routeProvider) {

		    $routeProvider
                .when('/', {
                    templateUrl: 'Views/Map/map.html',
                    controller: 'MapController'
                })
                .when('/termsOfUse', {
                    templateUrl: 'Views/TermsOfUse/termsOfUse.html',
                    controller: 'TermsOfUseController'
                 })
                .when('/purchases', {
                    templateUrl: 'Views/Purchases/purchases.html',
                    controller: 'PurchasesController'
                })
				.when('/about', {
					templateUrl: 'Views/About/about.html',
					controller: 'AboutController'
				})
				.otherwise({
				    redirectTo: '/'
				});
		}])

	.run([
        '$rootScope',
        'localization',
        'purchases',
		function (
            $rootScope,
            localization,
            purchases)
		{
		    localization.init(Environment.AvailableLanguages);

		    $rootScope.Environment = Environment;
		    $rootScope.Resources = localization;

		    document.addEventListener('deviceready', function () {

		        if (window.plugins && window.plugins.insomnia) {
		            window.plugins.insomnia.keepAwake();
		        }

		        navigator.globalization.getLocaleName(function (locale) {
                    var lang = locale.value.substr(0, 2);

                    $rootScope.$apply(function () {
                    	if (Environment.AvailableLanguages.indexOf(lang) >= 0) {
                    		localization.setLanguage(lang);
                    	}
                    	else {
                    		localization.setLanguage('en');
                    	}
                    });
		        });

		        if (store) {
		            $rootScope.$apply(function () {
		                purchases.init(store);
		            });
		        }
		        else
		        {
                    alert('Can`t initialize store!')
		        }
		           
		    }, false);
		}
	]);

$(function () {
    angular.bootstrap(document, ['parkItApp']);
});